﻿<?PHP
/* 	
SIGNUM-NET Włodzimierz Kessler
	Skrypt do wczytywania danych wysyłanych z programu FARA do bazy danych MySQL
	Wersja zaawansowana
	Wszelkie prawa zastrzeżone
	Dopuszcza się modyfikacje tego skryptu we własnym zakresie na własne potrzeby
	NIEDOZWOLONE jest odsprzedawanie tego skryptu
	
	Skrypt testowany był w określonym środowisku systemu operacyjnego, języka PHP i bazy MySQL
	
	!!! Nie ma żadnej gwarancji, że skrypt będzie działał prawidłowo w Twoim środowisku. Należy przed jego wdrożeniem samodzielnie sprawdzić jego działanie na docelowym serwerze !!!
*/
define ("FARA_INTENTIONS_SOURCE_FOLDER"	, 'fara-intencje-online');
define ("FARA_ZGLOSZENIA_FOLDER"		, 'zgloszenia');

define ("FARA_INTENTIONS_FILE_TYPE"			, 'fara_intencje');
define ("FARA_INTENTIONS_DELETE_FILE_TYPE"	, 'fara_intencje_deleted');
define ("FARA_INTENTIONS_TYPES_FILE_TYPE"	, 'fara_intencje_typy');
define ("FARA_CHURCHES_FILE_TYPE"			, 'fara_intencje_koscioly');
define ("FARA_SAINTS_FILE_TYPE"				, 'fara_patroni_niemodyfikowane');
define ("FARA_USER_SAINTS_FILE_TYPE"		, 'fara_patroni_modyfikowane');
define ("FARA_MCELEBRATIONS_FILE_TYPE"		, 'fara_swieta_ruchome');
define ("FARA_CCELEBRATIONS_FILE_TYPE"		, 'fara_swieta_stale');

define ("FARA_DEFAULT_INI_STYLES_FILE"		, 'fara_intencje_online.ini');

// style funkcji faraDzienText
define ("dtKeyParagraphFree"	, 'paragraf wolny');
define ("dtKeyParagraphClosed"	, 'paragraf zajęty');
define ("dtKeyFreeLink"			, 'link wolny');
define ("dtKeyClosedLink"		, 'link zajęty');
define ("dtKeySeparator"		, 'separator');
define ("dtKeyNoFreTimes"		, 'tekst gry brak wolnych');
define ("dtKeyNoIntentions"		, 'tekst gdy brak intencji');
define ("dtKeyNoData"			, 'tekst gdy brak danych');
define ("dtKeywordResult"		, '$wynik');
// style funkcji faraDzienDropDownList
define ("dddlKeySelect"			, 'atrybuty select');
define ("dddlKeyOption"			, 'atrybuty option');
// style funkcji faraKosciolyDropDownList
define ("kddlKeySelect"			, 'atrybuty select');
define ("kddlKeyOption"			, 'atrybuty option');
// style funkcji faraTerminyTable
define ("ttKeyStart"			, 'start');
define ("ttKeyDuration"			, 'dni');
define ("ttKeyFreeLink"			, 'link wolny');
define ("ttKeyClosedLink"		, 'link zajęty');
define ("ttKeyTimesInCells"		, 'godziny w osobnych komórkach');
define ("ttKeySeparator"		, 'separator godzin');
define ("ttKeyTableStyle"		, 'styl tabeli');
define ("ttKeyRowStyle"			, 'styl wiersza');
define ("ttKeyDateCellStyle"	, 'styl komórki z datą');
define ("ttKeyDateSundayCellStyle", 'styl komórki z datą gdy niedziela');
define ("ttKeyTimeCellStyle"	, 'styl komórki z godziną');
define ("ttKeyDateFormat"		, 'format daty');
define ("ttKeyUseEmptyDays"		, 'z pustymi dniami');
define ("ttKeyFreeTimeStyle"	, 'styl godziny wolnej');
define ("ttKeyClosedTimeStyle"	, 'styl godziny zajętej');
define ("ttKeyNoDataText"		, 'tekst gdy brak danych');
// style funkcji faraIntencjeTable
define ("itKeyNoDataText"		, 'tekst gdy brak danych');
define ("itKeyDateFormat"		, 'format daty');
define ("itKeyDateStyle"		, 'styl daty');
define ("itKeyDateSundayStyle"	, 'styl daty gdy niedziela');
define ("itKeyPatron"			, 'patron dnia');
define ("itKeyMCelebration"		, 'święto ruchome');
define ("itKeyCCelebration"		, 'święto stałe');
define ("itKeySubtitleStyle"	, 'styl śródtytułu');
define ("itKeyTableStyle"		, 'styl tabeli');
define ("itKeyRowStyle"			, 'styl wiersza');
define ("itKeyTimeCellStyle"	, 'styl komórki z godziną');
define ("itKeyContentCellStyle"	, 'styl komórki z treścią');
define ("itKeyFreeTimes"		, 'wolne terminy');
define ("itKeyFreeTimeText"		, 'tekst dla terminu wolnego');
define ("itKeyFreeTimeCellStyle", 'styl komórki z treścią dla terminu wolnego');
define ("itKeyFreeTimeLink"		, 'link pod tekstem dla terminu wolnego');
define ("itKeyFreeTimeBookmark" , 'zakładka przed wolnym terminem');
define ("itKeyLinkContentsOnTheSameTime"	, 'łączenie treści w tym samym czasie');
define ("itKeySeparatorContentsOnTheSameTime"	, 'separator treści w tym samym czasie');
define ("itKeyTypeOfLinkedContnetsOnTheSameTime", 'łączenie treści gdy typ');
define ("itLinkContentNo"						, 0);
define ("itLinkContentYes" 						, 1);
define ("itKeyChurchNameLocation", 'miejsce na nazwę kościoła');
define ("itKeyChurchNameLocationNone", 0);
define ("itKeyChurchNameLocationAbove", 1);
define ("itKeyChurchNameLocationBelow", 2);
define ("itKeyChurchNameStyle", 'nazwa kościoła');

// zgłoszenia
define ("zgRezerwowanie"						, 'tekst w trakcie rezerwowania');
define ("zgWalidacja"							, 'walidacja');
define ("zgTypNieWalidowany"					, 'typ wykluczony z walidacji');
define ("zgPotwierdzona"						, 0);
define ("zgNiePotwierdzona"						, 1);

define ("FARA_WSZYSTKIE_KOSCIOLY"			,  -1);
define ("FARA_DATA_POZA_ZAKRESEM"			,  -2);
define ("FARA_TERMIN_BRAK_DANYCH"			,  -1);
define ("FARA_TERMIN_WOLNY"					,   1);
define ("FARA_TERMIN_ZAJETY"				,   0);
define ("FARA_TERMIN_DOWOLNY"				,   2);
define ("FARA_DATABASE_CONNECTION_CANCELED"	,-100);
define ("FARA_SEPARATOR_TERMINOW"			,', ' );
define ("FARA_FORMAT_DATY_DOMYSLNY"			, '%d.%m.%Y');

define ("sysKeyHistory"							, 'historia');
define ("FARA_INTENCJE_WSZYSTKO"				, 0);
define ("FARA_INTENCJE_OD_DZISIAJ"				, 1);
define ("FARA_INTENCJE_OD_BIEZACEGO_TYGODNIA"	, 2);
define ("FARA_INTENCJE_OD_BIEZACEGO_MIESIACA"	, 3);
define ("FARA_INTENCJE_OD_POCZATKU_ROKU"		, 4);
define ("FARA_INTENCJE_OD_NASTEPNEGO_TYGODNIA"	, 5);
define ("FARA_INTENCJE_OD_NASTEPNEGO_MIESIACA"	, 6);
define ("FARA_INTENCJE_OD_NASTEPNEGO_ROKU"		, 7);

define ("FARA_KEYWORD_DATA"						, '$data');
define ("FARA_KEYWORD_GODZINA"					, '$godzina');
define ("FARA_KEYWORD_KOSCIOL"					, '$kosciol');
define ("FARA_KEYWORD_TYTUL"					, '$tytuł');

define ("FARA_ZGLOSZENIE_TERMIN_ZAJETY"			, 0);
define ("FARA_ZGLOSZENIE_TERMIN_PRZYJETY"		, 1);
define ("FARA_ZGLOSZENIE_BLAD_WYSYLANIA"		, -1);

$fara = new FaraIntentionsCalendar();
if (isset ($_GET['tryb']) and strtolower ($_GET['tryb'])=='instaluj') $fara->install();
if (isset ($_GET['loading']) and $_GET['loading']==1) $fara->dataLoad(FARA_INTENTIONS_SOURCE_FOLDER);

class FaraIntentionsCalendar {
	var $dbSourceFolder 			= '';
	var $History					= FARA_INTENCJE_OD_BIEZACEGO_TYGODNIA;
	var $emailToSendErrorMessage	= '';
	var $emailSender				= '';
	var $UTF8correction				= 0;
	var $con = 0;
	var $tablePrefix				= "";
	var $emailWithRequest			= "";

function __construct () {
require_once ('fara_intencje_online_konfiguracja.php');
$this->emailToSendErrorMessage 	= $emailToSendErrorMessage;
$this->emailSender				= $emailSender;
$this->dbSourceFolder			= $mainFolder.FARA_INTENTIONS_SOURCE_FOLDER;
$this->UTF8correction			= $UTF8correction;
$this->tablePrefix				= $tablePrefix;
$this->emailWithRequest			= $emailWithRequest;
define ("FARA_INTENTIONS_TABLE"			, $this->tablePrefix.'faraIntencje');
define ("FARA_INTENTIONS_TYPES_TABLE"	, $this->tablePrefix.'faraTypyIntencji');
define ("FARA_CHURCHES_TABLE"			, $this->tablePrefix.'faraIntencjeKoscioly');
define ("FARA_SAINTS_TABLE"				, $this->tablePrefix.'faraPatroniNiemodyfikowane');
define ("FARA_USER_SAINTS_TABLE"		, $this->tablePrefix.'faraPatroniModyfikowane');
define ("FARA_MCELEBRATIONS_TABLE"		, $this->tablePrefix.'faraSwietaRuchome');
define ("FARA_CCELEBRATIONS_TABLE"		, $this->tablePrefix.'faraSwietaStale');
$this->con  = mysqli_connect($dbHost, $dbUser, $dbPassword) or $this->sendErrorMessage ('Brak połączenia z bazą danych');
$config = $this->iniGetSection ('system', $this->getConfigFileName());
$this->history = $config[sysKeyHistory];
mysqli_select_db($this->con,$dbName);
}

function sendErrorMessage ($command) {
if (strlen ($this->emailToSendErrorMessage) > 0) {
	mail ($this->emailToSendErrorMessage, 
		  'Komunikat o błędzie w trakcie obsługi bazy terminów intencji na stronie WWW', 
		  $command,
		  '',
		  '-f'.$this->emailSender);
}
}

function dieWithMessage ($query) {
die ("Nie można wykonać operacji: <br/>".$query."<br/><br/>Error no: ".mysqli_errno($this->con).": ".mysqli_error($this->con));
}

// INSTALACJA - TWORZENIE TABLICY
function install () {
$query		= 'CREATE TABLE IF NOT EXISTS `'.FARA_CHURCHES_TABLE.'` (`faraID` integer NOT NULL,`nazwa` VARCHAR (254) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL) DEFAULT CHARSET=utf8 COLLATE=utf8_polish_ci';
$handles	= mysqli_query ($this->con, $query) or $this->dieWithMessage ($query);

$query 		= 'CREATE TABLE IF NOT EXISTS `'.FARA_INTENTIONS_TABLE.'` (`faraID` integer NOT NULL, `data` int (8) NOT NULL,`godzina` int (4) NOT NULL, `tresc` VARCHAR (10000) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL, `kosciolID` integer NOT NULL, `wolny` int (1) NOT NULL, gregorianka integer NOT NULL, `typID` integer NOT NULL, , `nie_potwierdzona` boolean NOT NULL,) DEFAULT CHARSET=utf8 COLLATE=utf8_polish_ci';
$handles	= mysqli_query ($this->con, $query) or $this->dieWithMessage ($query);
$query 		= 'ALTER TABLE `'.FARA_INTENTIONS_TABLE.'` ADD INDEX (`data`)';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie indeksu w tabeli intencji)");
$query 		= 'ALTER TABLE `'.FARA_INTENTIONS_TABLE.'` ADD INDEX (`faraID`)';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie indeksu w tabeli intencji)");

$query		= 'CREATE TABLE IF NOT EXISTS `'.FARA_INTENTIONS_TYPES_TABLE.'` (`faraID` integer NOT NULL,`nazwa` VARCHAR (254) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL) DEFAULT CHARSET=utf8 COLLATE=utf8_polish_ci';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie tabeli typów intencji)");

$query		= 'CREATE TABLE IF NOT EXISTS `'.FARA_SAINTS_TABLE.'` (`dzien` int (2) NOT NULL, `miesiac` int (2) NOT NULL,`nazwa` VARCHAR (254) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`typ` VARCHAR (50) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL) DEFAULT CHARSET=utf8 COLLATE=utf8_polish_ci';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie tabeli świętych)");
$query 		= 'ALTER TABLE `'.FARA_SAINTS_TABLE.'` ADD INDEX (`dzien`)';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie indeksu w tabeli świętych)");

$query		= 'CREATE TABLE IF NOT EXISTS `'.FARA_USER_SAINTS_TABLE.'` (`faraID` integer NOT NULL,`dzien` int (2) NOT NULL, `miesiac` int (2) NOT NULL,`nazwa` VARCHAR (254) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL) DEFAULT CHARSET=utf8 COLLATE=utf8_polish_ci';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie uzupełnienia tabeli świętych)");
$query 		= 'ALTER TABLE `'.FARA_SAINTS_TABLE.'` ADD INDEX (`dzien`)';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie indeksu w uzupełnieniu tabeli świętych)");

$query		= 'CREATE TABLE IF NOT EXISTS `'.FARA_MCELEBRATIONS_TABLE.'` (`faraID` integer NOT NULL,`data` int (8) NOT NULL, `nazwa` VARCHAR (254) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`typ` VARCHAR (100) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL) DEFAULT CHARSET=utf8 COLLATE=utf8_polish_ci';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie tabeli świąt ruchomych)");
$query 		= 'ALTER TABLE `'.FARA_MCELEBRATIONS_TABLE.'` ADD INDEX (`data`)';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie indeksu w tabeli świąt ruchomych)");

$query		= 'CREATE TABLE IF NOT EXISTS `'.FARA_CCELEBRATIONS_TABLE.'` (`faraID` integer NOT NULL,`dzien` int (2) NOT NULL, `miesiac` int (2) NOT NULL, `nazwa` VARCHAR (254) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL) DEFAULT CHARSET=utf8 COLLATE=utf8_polish_ci';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie tabeli świąt stałych)");
$query 		= 'ALTER TABLE `'.FARA_CCELEBRATIONS_TABLE.'` ADD INDEX (`dzien`)';
$handles	= mysqli_query ($this->con, $query) or die ("Zerwano połączenie z serwerem ! (tworzenie indeksu w tabeli świąt stałych)");

$message	= '<html><head><meta http-equiv="content-type" content="text/html; charset=utf-8" /></head><body>'.
			  '<p style="font-family:Verdana,Calibri,Arial;font-size:11px;">'.
			  'Instalacja została zakończona.<br/>W bazie danych zostały utworzone tablice:<ul>'.
			  '<li>'.FARA_INTENTIONS_TABLE.'</li>'.
			  '<li>'.FARA_INTENTIONS_TYPES_TABLE.'</li>'.
			  '<li>'.FARA_CHURCHES_TABLE.'</li>'.
			  '<li>'.FARA_SAINTS_TABLE.'</li>'.
			  '<li>'.FARA_USER_SAINTS_TABLE.'</li>'.
			  '<li>'.FARA_MCELEBRATIONS_TABLE.'</li>'.
			  '<li>'.FARA_CCELEBRATIONS_TABLE.'</li>'.
			  '</ul><br/>Proszę teraz wykonać pozostałe kroki konfiguracyjne'.
			  '</p></body></html>';
echo $message;			  
}

// ŁADOWANIE DANYCH Z PLIKÓW 
function saveClearMark ($text) {
return;
$ip			 = getenv ("REMOTE_ADDR");
$host		 = gethostbyaddr ($ip);
$currentTime = date ('d/m/Y H:i');
$content 	 = "<?xml version=\"1.0\" encoding=\"utf-8\"?>
<clear>
  <record>
   <info>$text</info>
   <ip>$ip</ip>
   <host>$host</host>
   <time>$currentTime</time>
  </record>
</clear>";
$fname = time().str_replace ('.', '', getenv ("REMOTE_ADDR"));
$fileName = $fname;
$i=0;
while (file_exists ($this->dbSourceFolder.'/marks/'.$fileName.'.xml')) {
	$fileName = $fname.$i++;
}	
file_put_contents ($this->dbSourceFolder.'/marks/'.$fileName.'.xml', $content);
mail ("admin@kalawa.salezjanie.pl", 
	  'Kasowanie bazy przez zewnętrzny proces', 
	  $content,
	  '',
	  '-f'.$this->emailSender);
}

function dataLoad () {
$sourceDir = (func_num_args () > 0) ? func_get_arg (0) : $this->dbSourceFolder;
$pathHandle = opendir ($sourceDir);
if (!$pathHandle) {
	if (isset ($_GET['silent_mode']) and $_GET['silent_mode']=='0')
		echo 'Nie można odczytać zawartości katalogu: '.$sourceDir.'<br/>Ładowanie nie powiodło się';
	  else				
		$this->sendErrorMessage ('Nie można odczytać zawartości katalogu: '.$sourceDir);
	return;
}
$clear = (isset ($_GET['clear']) and $_GET['clear']==1);
// Skasowanie wpisów starszych niż dzisiaj lub wszystkich:
if ($clear) {
	$this->saveClearMark("Kasowanie całości");
	// SKASOWANIE CAŁOŚCI
	$query = 'DELETE FROM  `'.FARA_INTENTIONS_TABLE.'`';
	mysqli_query ($this->con, $query) or $this->sendErrorMessage ('Nie można skasować danych: '.$query);
	$query = 'DELETE FROM  `'.FARA_INTENTIONS_TYPES_TABLE.'`';	
	mysqli_query ($this->con, $query) or $this->sendErrorMessage ('Nie można skasować danych: '.$query);	
	$query = 'DELETE FROM  `'.FARA_CHURCHES_TABLE.'`';	
	mysqli_query ($this->con, $query) or $this->sendErrorMessage ('Nie można skasować danych: '.$query);
	$query = 'DELETE FROM  `'.FARA_SAINTS_TABLE.'`';	
	mysqli_query ($this->con, $query) or $this->sendErrorMessage ('Nie można skasować danych: '.$query);
	$query = 'DELETE FROM  `'.FARA_USER_SAINTS_TABLE.'`';	
	mysqli_query ($this->con, $query) or $this->sendErrorMessage ('Nie można skasować danych: '.$query);
	$query = 'DELETE FROM  `'.FARA_MCELEBRATIONS_TABLE.'`';	
	mysqli_query ($this->con, $query) or $this->sendErrorMessage ('Nie można skasować danych: '.$query);
	$query = 'DELETE FROM  `'.FARA_CCELEBRATIONS_TABLE.'`';	
	mysqli_query ($this->con, $query) or $this->sendErrorMessage ('Nie można skasować danych: '.$query);	
} else if ($this->history>0) {	
	// SKASOWANIE WPISÓW HISTORYCZNYCH	
	$this->saveClearMark("Kasowanie historycznych dla data<".$this->getFirstDate());
	$query = 'DELETE FROM  `'.FARA_INTENTIONS_TABLE.'` WHERE `data`<'.$this->getFirstDate();
	mysqli_query ($this->con, $query) or $this->sendErrorMessage ('Nie można skasować danych historycznych: '.$query);
	$query = 'DELETE FROM  `'.FARA_MCELEBRATIONS_TABLE.'` WHERE `data`<'.$this->getFirstDate();
	mysqli_query ($this->con, $query) or $this->sendErrorMessage ('Nie można skasować danych historycznych: '.$query);
}	
$total = 0;

// APPEND BLANK -> REPLACE MOŻE SPOWODWAĆ POWSTANIE 2 PLIKÓW DLA TEGO SAMEGO ID - TRZEBA TE PLIKI JAKOŚ TAK POSORTOWAĆ
// ŻEBY NAJPIERW PRZETWARZAĆ PLIKI STARSZE, A POTEM CORAZ MŁODSZE
// PLIKI TRZEBA WIĘC NAJPIERW POSORTOWAĆ WG. FUNKCJI FILEMTIME, a dopiero potem przetwarzać

while (false !== ($file = readdir($pathHandle))) 
	if (is_file ($sourceDir.'/'.$file)) {
		$localOrderInSession 	= substr ($file, 0, 6);
		$timeSignature			= substr ($file, 6, 16);
		$userID					= substr ($file, 22, 5);
		$key = $timeSignature.$localOrderInSession.$userID;				
		$files[$key] = $file;
	}
	
if (!isset ($files) or count ($files)==0) {
	if (isset ($_GET['silent_mode']) and $_GET['silent_mode']=='0')
		echo '<html><head><meta http-equiv="content-type" content="text/html; charset=utf-8" /></head><body>'.
			'<p style="font-family:Verdana,Calibri,Arial;font-size:11px;">'.
			'Ładowanie zostało przeprowadzone, ale nie znaleziono żadnych danych do wczytania'.
			'</p></body></html>';
	return ;
}
ksort ($files);
closedir($pathHandle);
foreach ($files as $file) {
	$path = $sourceDir.'/'.$file;	
	if 		(is_file ($path) and $this->fileNameExtension($path)==FARA_INTENTIONS_FILE_TYPE		) $total += $this->loadIntentions($path);
	else if (is_file ($path) and $this->fileNameExtension($path)==FARA_INTENTIONS_TYPES_FILE_TYPE	) $total += $this->loadIntentionsTypes($path);
	else if (is_file ($path) and $this->fileNameExtension($path)==FARA_CHURCHES_FILE_TYPE			) $total += $this->loadChurches($path);			 
	else if (is_file ($path) and $this->fileNameExtension($path)==FARA_SAINTS_FILE_TYPE			) $total += $this->loadSaints($path);			 
	else if (is_file ($path) and $this->fileNameExtension($path)==FARA_USER_SAINTS_FILE_TYPE		) $total += $this->loadUserSaints($path);			 
	else if (is_file ($path) and $this->fileNameExtension($path)==FARA_MCELEBRATIONS_FILE_TYPE	) $total += $this->loadMCelebrations($path);			 
	else if (is_file ($path) and $this->fileNameExtension($path)==FARA_CCELEBRATIONS_FILE_TYPE	) $total += $this->loadCCelebrations($path);
	else if (is_file ($path) and $this->fileNameExtension($path)==FARA_INTENTIONS_DELETE_FILE_TYPE) $total += $this->loadDeleteIntentions($path);
}

if (isset ($_GET['silent_mode']) and $_GET['silent_mode']=='0')
	echo '<html><head><meta http-equiv="content-type" content="text/html; charset=utf-8" /></head><body>'.
		 '<p style="font-family:Verdana,Calibri,Arial;font-size:11px;">'.
		 'Ładowanie danych zostało wykonane. Liczba zmian: '.$total.
		 '</p></body></html>';
}

function loadIntentions ($path) {	
// rename ($path, $this->dbSourceFolder.'/trash/'. basename($path));
// $contentArray 	= file ($this->dbSourceFolder.'/trash/'. basename($path));
$total			= 0;
$contentArray 	= file ($path);
unlink ($path);
foreach ($contentArray as $line) {
	$info		= explode ('|', $line);			
	//  faraID, id kościoła, rrrrmmdd, ggmm, wolny (1|0), tresc
	$id			= trim ($info [0]);	
	if (strlen($id)==0) continue;
	$church		= $info [1];	
	$date		= $info [2];
	$time		= $info [3];
	$free		= $info [4];
	$gregorian	= $info [5];	
	$type		= $info [6];	
	$content	= trim (str_replace ('&pipe', '|', $info [7]));	
	$confirmed 	= $info [8];	
	$query		= 'DELETE FROM `'.FARA_INTENTIONS_TABLE.'` WHERE `faraID`='.$id;
	$sqlHandle 	= mysqli_query ($this->con, $query) or $this->sendErrorMessage ($query);
	$total++;	
	if ($date > 0 and $date >= $this->getFirstDate()) {
		$query		= 'INSERT INTO `'.FARA_INTENTIONS_TABLE.'` (`faraID`, `kosciolID`, `data`, `godzina`, `wolny`, `tresc`, `gregorianka`, `typID`, `nie_potwierdzona`) '.
					  'VALUES ('.$id.','.$church.','.$date.','.$time.','.$free.',"'.$content.'",'.$gregorian.','.$type.','.$confirmed.')';		
		$sqlHandle 	= mysqli_query ($this->con, $query) or $this->sendErrorMessage ($query);
		$total++;
	}
}
return $total;
}

function loadDeleteIntentions ($path) {
// rename ($path, $this->dbSourceFolder.'/trash/'. basename($path));
// $contentArray 	= file ($this->dbSourceFolder.'/trash/'. basename($path));
$contentArray 	= file ($path);
$total			= 0;
unlink ($path);
foreach ($contentArray as $line) {
	$info		= explode ('|', $line);			
	//  faraID, id kościoła, rrrrmmdd, ggmm, wolny (1|0), tresc
	$date		= $info [0];	
	if (strlen($date)==0) continue;
	$church		= $info [1];	
	$query		= 'DELETE FROM `'.FARA_INTENTIONS_TABLE.'` WHERE `data`<'.$date;
	if ($church>0) $query .= ' and `kosciolID`='.$church;
	$sqlHandle 	= mysqli_query ($this->con, $query) or $this->sendErrorMessage ($query);
	$total++;
}
return $total;
}

function loadChurches ($path) {

$this->saveClearMark("loadChurches: ".basename($path));

//rename ($path, $this->dbSourceFolder.'/trash/'. basename($path));
//$contentArray 	= file ($this->dbSourceFolder.'/trash/'. basename($path));
$contentArray 	= file ($path);
$total			= 0;
unlink ($path);
foreach ($contentArray as $line) {
	$info		= explode ('|', $line);
	$id			= trim ($info [0]);
	if (strlen($id)==0) continue;
	$name		= trim (str_replace ('&pipe', '|', $info [1]));	
	$query = 'DELETE FROM  `'.FARA_CHURCHES_TABLE.'` WHERE `faraID`='.abs($id);		
	$sqlHandle = mysqli_query ($this->con, $query) or $this->sendErrorMessage ($query);
	if ($id<0 and $sqlHandle) {
		// Skaowanie, powoduje też kasację danych z księgi intencji dotyczących tego kościoła
		$query = 'DELETE FROM  `'.FARA_INTENTIONS_TABLE.'` WHERE `kosciolID`='.abs($id);		
		$sqlHandle = mysqli_query ($this->con, $query) or $this->sendErrorMessage ($query);
	} else {
		$name		= trim (str_replace ('&pipe', '|', $info [1]));		
		$query		= 'INSERT INTO `'.FARA_CHURCHES_TABLE.'` (`faraID`, `nazwa`) VALUES ('.$id.',"'.$name.'")';
		$sqlHhandle = mysqli_query ($this->con, $query) or $this->sendErrorMessage ('Nie można wykonać: '.$query);		
	}
	$total++;
}	
return $total;
}

function loadIntentionsTypes ($path) {
//rename ($path, $this->dbSourceFolder.'/trash/'. basename($path));
//$contentArray 	= file ($this->dbSourceFolder.'/trash/'. basename($path));

$contentArray 	= file ($path);
$total			= 0;
unlink ($path);
foreach ($contentArray as $line) {
	$info		= explode ('|', $line);
	$id			= trim ($info [0]);
	if (strlen($id)==0) continue;
	$name		= trim (str_replace ('&pipe', '|', $info [1]));	
	$query = 'DELETE FROM  `'.FARA_INTENTIONS_TYPES_TABLE.'` WHERE `faraID`='.abs($id);		
	$sqlHandle = mysqli_query ($this->con, $query) or $this->sendErrorMessage ($query);
	if ($id>0 and $sqlHandle) {
		// $id < 0 tylko kasuje
		$name		= trim (str_replace ('&pipe', '|', $info [1]));		
		$query		= 'INSERT INTO `'.FARA_INTENTIONS_TYPES_TABLE.'` (`faraID`, `nazwa`) VALUES ('.$id.',"'.$name.'")';
		$sqlHhandle = mysqli_query ($this->con, $query) or $this->sendErrorMessage ('Nie można wykonać: '.$query);		
	}
	$total++;
}	
return $total;
}

function loadSaints ($path) {
//rename ($path, $this->dbSourceFolder.'/trash/'. basename($path));
//$contentArray 	= file ($this->dbSourceFolder.'/trash/'. basename($path));

$query			= 'DELETE FROM `'.FARA_SAINTS_TABLE.'`';
$sqlHandle 		= mysqli_query ($this->con, $query) or $this->sendErrorMessage ($query);
$contentArray 	= file ($path);
$total			= 0;
unlink ($path);
foreach ($contentArray as $line) {
	$info		= explode ('|', $line);			
	//  dzien, miesiac, nazwa, typ
	$day		= trim ($info [0]);
	if (strlen($day)==0) continue;
	$month		= $info [1];				
	$name		= trim (str_replace ('&pipe', '|', $info [2]));					
	$type		= trim (str_replace ('&pipe', '|', $info [3]));					
	$query		= 'INSERT INTO `'.FARA_SAINTS_TABLE.'` (`dzien`, `miesiac`, `nazwa`, `typ`) '.
				  'VALUES ('.$day.','.$month.',"'.$name.'","'.$type.'")';
	$sqlHandle 	= mysqli_query ($this->con, $query) or $this->sendErrorMessage ($query);
	$total++;	
}
return $total;
}

function loadUserSaints ($path) {
//rename ($path, $this->dbSourceFolder.'/trash/'. basename($path));
//$contentArray 	= file ($this->dbSourceFolder.'/trash/'. basename($path));

$contentArray 	= file ($path);
$total			= 0;
unlink ($path);
foreach ($contentArray as $line) {
	$info		= explode ('|', $line);			
	//  id, dzien, miesiac, nazwa
	$id			= trim ($info [0]);	
	if (strlen($id)==0) continue;
	$query = 'DELETE FROM  `'.FARA_USER_SAINTS_TABLE.'` WHERE `faraID`='.abs($id);		
	$sqlHandle = mysqli_query ($this->con, $query) or $this->sendErrorMessage ($query);
	if ($id>0 and $sqlHandle) {
		// $id < 0 tylko kasuje
		$day		= $info [1];
		$month		= $info [2];
		$name		= trim (str_replace ('&pipe', '|', $info [3]));			
		$query		= 'INSERT INTO `'.FARA_USER_SAINTS_TABLE.'` (`faraID`, `dzien`, `miesiac`, `nazwa`) '.
					  'VALUES ('.$id.','.$day.','.$month.',"'.$name.'")';
		$sqlHandle 	= mysqli_query ($this->con, $query) or $this->sendErrorMessage ($query);
		$total++;	
	}
}
return $total;
}

function loadMCelebrations ($path) {	
$contentArray 	= file ($path);
$total			= 0;
unlink ($path);
foreach ($contentArray as $line) {
	$info		= explode ('|', $line);			
	//  id, data, nazwa, typ
	$id			= trim ($info [0]);
	if (strlen($id)==0) continue;	
	$date		= $info [1];	
	$query = 'DELETE FROM  `'.FARA_MCELEBRATIONS_TABLE.'` WHERE `faraID`='.abs($id);		
	$sqlHandle = mysqli_query ($this->con, $query) or $this->sendErrorMessage ($query);
	if ($id>0 and $sqlHandle) {
		// $id < 0 tylko kasuje
		$name		= trim (str_replace ('&pipe', '|', $info [2]));					
		$type		= trim (str_replace ('&pipe', '|', $info [3]));					
		$query		= 'INSERT INTO `'.FARA_MCELEBRATIONS_TABLE.'` (`faraID`, `data`, `nazwa`, `typ`) '.
					   'VALUES ('.$id.','.$date.',"'.$name.'","'.$type.'")';
	$sqlHandle 	= mysqli_query ($this->con, $query) or $this->sendErrorMessage ($query);
	$total++;	
	}
}
return $total;
}

function loadCCelebrations ($path) {
$contentArray 	= file ($path);
$total			= 0;
unlink ($path);
foreach ($contentArray as $line) {
	$info		= explode ('|', $line);			
	//  id, dzien, miesiac, nazwa
	$id			= trim ($info [0]);	
	if (strlen($id)==0) continue;
	$query = 'DELETE FROM  `'.FARA_CCELEBRATIONS_TABLE.'` WHERE `faraID`='.abs($id);		
	$sqlHandle = mysqli_query ($this->con, $query) or $this->sendErrorMessage ($query);
	if ($id>0 and $sqlHandle) {
		// $id < 0 tylko kasuje
		$day		= $info [1];
		$month		= $info [2];
		$name		= trim (str_replace ('&pipe', '|', $info [3]));					
		$query		= 'INSERT INTO `'.FARA_CCELEBRATIONS_TABLE.'` (`faraID`, `dzien`, `miesiac`, `nazwa`) '.
					  'VALUES ('.$id.','.$day.','.$month.',"'.$name.'")';
		$sqlHandle 	= mysqli_query ($this->con, $query) or $this->sendErrorMessage ($query);
		$total++;	
	}
}
return $total;
}
		
// FUNKCJE INTERFEJSU DLA PROGRAMISTY STRONY
function faraTermin () {
$date	= func_get_arg (0);
$time	= func_get_arg (1);
$church	= (func_num_args () > 2) ? func_get_arg (2) : FARA_WSZYSTKIE_KOSCIOLY;

if ($this->scriptDateFromString ($date) < $this->today()) return FARA_DATA_POZA_ZAKRESEM;
$query	= 'SELECT `wolny` FROM `'.FARA_INTENTIONS_TABLE.'` WHERE (`data`='.$this->scriptDateFromString ($date).') and (`godzina`='.str_replace (':', '', $time).')';
if ($church != FARA_WSZYSTKIE_KOSCIOLY) {
	$query .= ' and (`kosciolID`='.$church.')';
}
$handle = mysqli_query ($this->con, $query);
if (!$handle) {
	$this->sendErrorMessage ('Zerwane połączenie ze stroną'); 
	return FARA_DATABASE_CONNECTION_CANCELED;
}
$rows = mysqli_num_rows ($handle);
if ($rows == 0) {
	return FARA_TERMIN_BRAK_DANYCH;
}
for ($row=0; $row<$rows; $row++) {
	$record	= mysqli_fetch_object ($handle);
	if ($record->wolny==FARA_TERMIN_WOLNY) return FARA_TERMIN_WOLNY;
}
return FARA_TERMIN_ZAJETY;
}

function faraTerminy () {
$date1 		= func_get_arg (0);
$state		= func_get_arg (1);
$date2		= (func_num_args () > 2) ? func_get_arg (2) : '';
$withEmpty	= (func_num_args () > 3) ? func_get_arg (3) : FALSE;
$church		= (func_num_args () > 4) ? func_get_arg (4) : FARA_WSZYSTKIE_KOSCIOLY;

if (strlen ($date1)==0) $date1 = $this->today(); 
if (strlen ($date2)>0) {
	if ($this->scriptDateFromString ($date2) == $date1) {
		$date2 = '';
	} else if ($this->scriptDateFromString ($date2) < $date1) {
		$date1 = $this->scriptDateFromString ($date2);
		$date2 = $date1;
	}
}
$startDate = $this->scriptDateFromString ($date1);
if (strlen ($startDate)==0) return FALSE;
$datesScope = (strlen ($this->scriptDateFromString ($date2))>0);
if ($datesScope) $endDate = $this->scriptDateFromString ($date2);
$query	= 'SELECT `data`, `godzina`, `wolny`, `kosciolID` FROM `'.FARA_INTENTIONS_TABLE.'` WHERE ';
if ($church != FARA_WSZYSTKIE_KOSCIOLY) $query .= '(`kosciolID`='.$church.') and ';
if (!$datesScope) {
	$query .= '(`data`='.$startDate.') ';
} else {
	$query .= '(`data`>='.$startDate.') and (`data`<='.$endDate.')';
}
if ($state==FARA_TERMIN_WOLNY) $query .= ' and (`wolny`=1)';
else if ($state==FARA_TERMIN_ZAJETY) $query .= ' and (`wolny`=0)';
$query .= ' ORDER BY data, godzina';
$handle = mysqli_query ($this->con, $query);
if (!$handle) {
	$this->sendErrorMessage ('Zerwane połączenie z bazą danych w trakcie wykonywania funkcji "faraTerminy"'); 
	return FARA_DATABASE_CONNECTION_CANCELED;
}
$rowsInResult = mysqli_num_rows ($handle);
if ($rowsInResult == 0) return FALSE;
// KONKRETNY DZIEŃ
if (!$datesScope) {
	$timeID = 0;
	for ($row=0; $row<$rowsInResult; $row++) {
		$record 			= mysqli_fetch_object ($handle);	
		$result [$timeID++]	= new FaraIntentionTime ($this->stringFromScriptDate ($record->data,'%Y-%m-%d'), $record->godzina, $record->wolny, $record->kosciolID);		
	}
	return (count ($result) == 0) ? FALSE : $result;
}
// ZAKRES DAT
$lastDate 	= '';
$lastRow 	= -1;
for ($row=0; $row<$rowsInResult; $row++) {
	$record = mysqli_fetch_object ($handle);
	if ($record->data != $lastDate) {
		$lastRow++; 
		$lastColumn=0;
		$lastDate = $record->data;
		$result [$lastRow] [$lastColumn] = $lastDate;
	}
	$result [$lastRow] [++$lastColumn] = new FaraIntentionTime ($this->stringFromScriptDate ($record->data,'%Y-%m-%d'), $record->godzina, $record->wolny, $record->kosciolID);
}
return ($withEmpty) ? $this->addEmptyRowsTo2DimensionsCalendar ($result, $startDate, $endDate) : $this->removeEmptyRowsFrom2DimensionsCalendar ($result);
}

function faraIntencje () {
$dateStart	= @func_get_arg (0);
$dateEnd	= @func_get_arg (1);
$useFree	= (func_num_args () > 2) ? func_get_arg (2) : 0 ;
$church		= (func_num_args () > 3) ? func_get_arg (3) : FARA_WSZYSTKIE_KOSCIOLY ;
$church		= (func_num_args () > 3) ? func_get_arg (3) : FARA_WSZYSTKIE_KOSCIOLY ;

if ($dateStart==FARA_INTENCJE_OD_DZISIAJ) $dateStart = $this->today();
else if ($dateStart==FARA_INTENCJE_OD_BIEZACEGO_TYGODNIA) $dateStart = $this->thisWeekDate();
else if ($dateStart==FARA_INTENCJE_OD_NASTEPNEGO_TYGODNIA) $dateStart = $this->nextWeekDate();
else if ($dateStart==FARA_INTENCJE_OD_BIEZACEGO_MIESIACA) $dateStart = $this->thisMonthDate();
else if ($dateStart==FARA_INTENCJE_OD_NASTEPNEGO_MIESIACA) $dateStart = $this->nextMonthDate();
else if ($dateStart==FARA_INTENCJE_OD_POCZATKU_ROKU) $dateStart = $this->thisYearDate();
else if ($dateStart==FARA_INTENCJE_OD_NASTEPNEGO_ROKU) $dateStart = $this->nextYearDate();
else $dateStart = $this->scriptDateFromString ($dateStart);

if (strlen ($dateEnd)==0 or $dateEnd==0) {
	$duration = 7;	
	$dateEnd  = $this->incScriptDate ($dateStart, $duration);
} else if ($dateEnd<0) $dateEnd = $this->addMonthsDate (-$dateEnd, $dateStart);
  else if ($dateEnd<19900101) $dateEnd  = $this->incScriptDate ($dateStart, $dateEnd-1);
  else $dateEnd = $this->scriptDateFromString ($dateEnd);
 
$query = 'SELECT * FROM `'.FARA_INTENTIONS_TABLE.'` WHERE (`data`>='.$dateStart.') and (`data`<='.$dateEnd.')';
if ($church>0) $query .= ' and (`kosciolID`='.$church.')';
$query .= ' ORDER BY `data`, `godzina`, `typID`';	// jeszcze dodaj sortowanie na tych zmarłych

$handle = mysqli_query ($this->con, $query);
if (!$handle) {
	$this->sendErrorMessage ('Zerwane połączenie z bazą danych w trakcie wykonywania funkcji "faraTerminy"'); 
	return FARA_DATABASE_CONNECTION_CANCELED;
}
$rowsInResult = mysqli_num_rows ($handle);
if ($rowsInResult == 0) return NULL;
$index=0;
for ($row=0; $row<$rowsInResult; $row++) {
	$record = mysqli_fetch_object ($handle);
	if (!$useFree and $record->wolny==FARA_TERMIN_WOLNY) continue;
	$result[$index++] = $record;
}
return $result;
}

// FUNKCJE WYSOKIEGO POZIOMU

function faraDzienText () {
$date 		= func_get_arg (0);
$state		= (func_num_args () > 1) ? func_get_arg (1) : FARA_TERMIN_WOLNY ;
$church		= (func_num_args () > 2) ? func_get_arg (2) : FARA_WSZYSTKIE_KOSCIOLY;
$configFile	= $this->getConfigFileName ((func_num_args () > 3) ? func_get_arg (3) : '');
$config	= $this->iniGetSection ('faraDzienText', $configFile);

$godziny = $this->faraTerminy ($date, $state, '', FALSE, $church);
if (!$godziny) {
	if ($state==FARA_TERMIN_WOLNY) return $config[dtKeyNoFreeTimes];
	if ($state==FARA_TERMIN_ZAJETY) return $config[dtKeyNoIntentions];
	return  $config[dtKeyNoData];
}

$result = '';
foreach ($godziny as $time) {	
	if (strlen ($result) > 0) $result .= $config[dtKeySeparator];
	// link
	if 		($time->stan==FARA_TERMIN_WOLNY		) $key = dtKeyFreeLink; 
	else if ($time->stan==FARA_TERMIN_ZAJETY	) $key = dtKeyClosedLink;
	else $key = dtKeyClosedLink;
	$link = $config[$key];			
	$hyperlink	= $this->transform (FARA_KEYWORD_GODZINA	, $time->godzina, $link);
	$hyperlink	= $this->transform (FARA_KEYWORD_DATA	, $time->data	, $hyperlink);
	$hyperlink	= $this->transform (FARA_KEYWORD_KOSCIOL	, $time->kosciol, $hyperlink);	
	// tekst	
	if (strlen ($link)>0) $text = '<a href="'.$hyperlink.'">'.$time->godzina.'</a>'; else $text = $time->godzina;	
	// pełny tekst
	if 		($state == FARA_TERMIN_DOWOLNY  and $time->stan==FARA_TERMIN_WOLNY ) $key = dtKeyParagraphFree;
	else if ($state == FARA_TERMIN_DOWOLNY  and $time->stan==FARA_TERMIN_ZAJETY) $key = dtKeyParagraphClosed;
	else if ($state == FARA_TERMIN_WOLNY									   ) $key = dtKeyParagraphFree;
	else 																		 $key = dtKeyParagraphClosed;	
	$style = $config [$key];
	if ($style) $text  = str_replace (dtKeywordResult, $text, $style);
	$result .= $text;
}
return $result;
}

function faraDzienDropDownList () {
$date 		= func_get_arg (0);
$church		= (func_num_args () > 1) ? func_get_arg (1) : FARA_WSZYSTKIE_KOSCIOLY ;
$configFile	= $this->getConfigFileName ((func_num_args () > 2) ? func_get_arg (2) : '');
$config		= $this->iniGetSection ('faraDzienDropDownList', $configFile);
$selectAttributes = $config[dddlKeySelect];
$optionAttributes = $config[dddlKeyOption];
$godziny 	= $this->faraTerminy ($date, FARA_TERMIN_WOLNY, '', FALSE, $church);
$result		= '<select '.$selectAttributes.'>';
if ($godziny) 
	for ($timeID=0; $timeID<count($godziny); $timeID++)
		$result .= ' <option '.$optionAttributes.' value="'.$godziny[$timeID]->godzina.'"'. (($timeID==0) ? ' selected' : '').'>'.$godziny[$timeID]->godzina.'</option>';
$result	.= '</select>';
return $result;
}

function faraKosciolyDropDownList () {
$configFile	= $this->getConfigFileName ((func_num_args () > 0) ? func_get_arg (0) : '');
$config		= $this->iniGetSection ('faraKosciolyDropDownList', $configFile);
$selectAttributes = $config[kddlKeySelect];
$optionAttributes = $config[kddlKeyOption];
$query		= 'select * from `'.FARA_CHURCHES_TABLE.'` order by nazwa';
$handle 	= mysqli_query ($this->con, $query);
if (!$handle) {
	$this->sendErrorMessage ('Zerwane połączenie z bazą danych w trakcie wykonywania funkcji "faraKosciolyDropDownList"'); 
	return '';
}
$rowsInResult = mysqli_num_rows ($handle);
if ($rowsInResult == 0) return '';

$result	= '<select '.$selectAttributes.'>';
for ($row=0; $row<$rowsInResult; $row++) {
	$record = mysqli_fetch_object ($handle);		
	$result .= ' <option '.$optionAttributes.' value="'.$record->kosciolID.'"'. (($row==0) ? ' selected' : '').'>'.$record->nazwa.'</option>';
}
$result	.= '</select>';
$result = $this->correctToUTF8($result);
return $result;
}

function faraTerminyTable () {
$dateStart	= (func_num_args () > 0) ? func_get_arg (0) : '' ;
$dateEnd	= (func_num_args () > 1) ? func_get_arg (1) : '' ;
$state		= (func_num_args () > 2) ? func_get_arg (2) : FARA_TERMIN_WOLNY ;
$church		= (func_num_args () > 3) ? func_get_arg (3) : FARA_WSZYSTKIE_KOSCIOLY ;
$configFile	= $this->getConfigFileName ((func_num_args () > 4) ? func_get_arg (4) : '');
$config		= $this->iniGetSection ('faraTerminyTable', $configFile);

if 		(strlen ($dateStart)==0) 							  $dateStart = $config[$ttKeyStart];
if      ($dateStart==FARA_INTENCJE_OD_DZISIAJ				) $dateStart = $this->today();
else if ($dateStart==FARA_INTENCJE_OD_BIEZACEGO_TYGODNIA	) $dateStart = $this->thisWeekDate();
else if ($dateStart==FARA_INTENCJE_OD_NASTEPNEGO_TYGODNIA	) $dateStart = $this->nextWeekDate();
else if ($dateStart==FARA_INTENCJE_OD_BIEZACEGO_MIESIACA	) $dateStart = $this->thisMonthDate();
else if ($dateStart==FARA_INTENCJE_OD_NASTEPNEGO_MIESIACA	) $dateStart = $this->nextMonthDate();
else if ($dateStart==FARA_INTENCJE_OD_POCZATKU_ROKU			) $dateStart = $this->thisYearDate();
else if ($dateStart==FARA_INTENCJE_OD_NASTEPNEGO_ROKU		) $dateStart = $this->nextYearDate();
else $dateStart = $this->scriptDateFromString ($dateStart);

if (strlen ($dateEnd)==0 or $dateEnd==0) {
	$duration = $config[ttKeyDuration];
	if (!$duration) $duration = 7;
	$dateEnd  = $this->incScriptDate ($dateStart, $duration);
} else if ($dateEnd<19900101) $dateEnd  = $this->incScriptDate ($dateStart, $dateEnd-1);
  else $dateEnd = $this->scriptDateFromString ($dateEnd);
 
$data = $this->faraTerminy ($dateStart, $state, $dateEnd, $config[ttKeyUseEmptyDays], $church);
if (!$data) return $config[ttKeyNoDataText];

$result = '<table '.$config[ttKeyTableStyle].'>';
foreach ($data as $day) {
	$currentDate = $this->stringFromScriptDate ($day[0], $config[ttKeyDateFormat]);	
	$result .= '<tr '.$config[ttKeyRowStyle].'>';
	$key	 = ($this->dayOfWeek ($day[0])==1) ? ttKeyDateSundayCellStyle : ttKeyDateCellStyle;
	$result .= '<td '.$config[$key].'>'.$currentDate.'</td>';	
	if (count ($day)>1) {		
		for ($timeID=1; $timeID < count($day); $timeID++) {			
			$time = $day[$timeID];			
			// cell
			if ($timeID==1  or $config[ttKeyTimesInCells]) $result .= '<td '.$config[ttKeyTimeCellStyle].'>'; 
			else if ($timeID>1) $result .= $config[ttKeySeparator];			
			// link
			if 		($time->stan==FARA_TERMIN_WOLNY ) $key = ttKeyFreeLink; 
			else if ($time->stan==FARA_TERMIN_ZAJETY) $key = ttKeyClosedLink;			
			else 									  $key = ttKeyClosedLink;
			$link = $config[$key];	
			$hyperlink = $this->transform (FARA_KEYWORD_DATA	, $time->data	, $link);
			$hyperlink = $this->transform (FARA_KEYWORD_GODZINA	, $time->godzina, $hyperlink);
			$hyperlink = $this->transform (FARA_KEYWORD_KOSCIOL	, $time->kosciol, $hyperlink);
			// content			
			if 		($time->stan==FARA_TERMIN_WOLNY ) $text = ($config[ttKeyFreeTimeStyle]	) ? $this->transform (FARA_KEYWORD_GODZINA, $time->godzina, $config[ttKeyFreeTimeStyle]) 	: $time->godzina;
			else if ($time->stan==FARA_TERMIN_ZAJETY) $text = ($config[ttKeyClosedTimeStyle]) ? $this->transform (FARA_KEYWORD_GODZINA, $time->godzina, $config[ttKeyClosedTimeStyle])	: $time->godzina;
			else 									  $text = ($config[ttKeyClosedTimeStyle]) ? $this->transform (FARA_KEYWORD_GODZINA, $time->godzina, $config[ttKeyClosedTimeStyle])	: $time->godzina;
			// rezultat			
			$result .= ($hyperlink) ? '<a href='.$hyperlink.'>'.$text.'</a>' : $text;			
			if ($config[ttKeyTimesInCells]) $result .= '</td>';
		}
		if (!$config[ttKeyTimesInCells]) $result .= '</td>';
	}
	$result .= '</tr>';
}
return $result.'</table>';
}

function faraIntencjeTable () {	
$dateStart	= (func_num_args () > 0) ? func_get_arg (0) : 1 ;
$dateEnd	= (func_num_args () > 1) ? func_get_arg (1) : 7 ;
$useFree	= (func_num_args () > 2) ? func_get_arg (2) : 0 ;
$church		= (func_num_args () > 3) ? func_get_arg (3) : FARA_WSZYSTKIE_KOSCIOLY ;
$configFile	= $this->getConfigFileName ((func_num_args () > 4) ? func_get_arg (4) : '');
$config		= $this->iniGetSection ('faraIntencjeTable', $configFile);
$intentions	= $this->faraIntencje($dateStart, $dateEnd, $useFree, $church);
if ($intentions==FARA_DATABASE_CONNECTION_CANCELED) return '';
if ($intentions==NULL) return $config[itKeyNoDataText];
$intentions	= $this->rebuildIntentionsOnTheSameTime ($intentions, $config);
$content 	= '';
$lastDate 	= 0;
$dateFormat = ($config[itKeyDateFormat]) ? $config[itKeyDateFormat] : '%A, %d %B %Y';
$churchNameLocation = $config[itKeyChurchNameLocation];
$churchStyle = $config[itKeyChurchNameStyle];
$bookmarkOnFree = ($config[itKeyFreeTimeBookmark]=='1');
$freeOrderNo = 1;
for ($row=0; $row<count($intentions); $row++) {
	$intention = $intentions[$row];
	if ($intention->data != $lastDate) {
		$lastDate = $intention->data;
		if ($row>0) $content .= '</table>';
		// Data
		$date 	  = $this->stringFromScriptDate ($intention->data, $dateFormat);
		$key 	  = ($this->dayOfWeek ($intention->data)==1) ? itKeyDateSundayStyle: itKeyDateStyle;
		$content .= ($config[$key]) ? $this->transform (FARA_KEYWORD_DATA, $date, $config[$key]) : $date;
		// Patron dnia, święto ruchome, święto stałe
		$subtitle = '';
		if ($config[itKeyPatron]	  ) $subtitle = $this->faraPatroniDnia ($intention->data);
		if ($config[itKeyMCelebration]) {
			$buffer = $this->faraSwietoRuchome ($intention->data);
			if ($buffer) $subtitle .= (($subtitle) ? ', ' : '').$buffer;
		}
		if ($config[itKeyCCelebration]) {
			$buffer = $this->faraSwietoStale ($intention->data);
			if ($buffer) $subtitle .= (($subtitle) ? ', ' : '').$buffer;
		}
		if ($config[itKeySubtitleStyle]) $subtitle = str_replace (FARA_KEYWORD_TYTUL, $subtitle, $config[itKeySubtitleStyle]);
		$content .= $subtitle;
		// Tabela z godzinami i treścią dla tego dnia
		$content .= '<table '.$config[itKeyTableStyle].'>';
	}
	$content .= '<tr>';
	// Komórka z godziną	
	if ($intention->godzina==0) $content .= '<td '.$config[itKeyTimeCellStyle].'></td>'; else
	$content .= '<td '.$config[itKeyTimeCellStyle].'>'.number_format ($intention->godzina/100, 2, ':', '').'</td>';	
	// Komórka z treścią
	if ($intention->wolny==FARA_TERMIN_WOLNY) {
		//itKeyFreeTimeLink
		$link = $config[itKeyFreeTimeLink];				
		if (strlen ($link)>0) {				
			$hyperlink	 = $this->transform (FARA_KEYWORD_GODZINA, number_format ($intention->godzina/100, 2, ':', ''), $link);
			$hyperlink	 = $this->transform (FARA_KEYWORD_DATA	, $this->stringFromScriptDate ($intention->data,'%Y-%m-%d'), $hyperlink);
			$hyperlink	 = $this->transform (FARA_KEYWORD_KOSCIOL, $intention->kosciolID, $hyperlink);
			
			if ($churchNameLocation==itKeyChurchNameLocationNone) {
				$massContent = '<a href='.$hyperlink.'>'.$config[itKeyFreeTimeText].'</a>';
			} else if ($churchNameLocation==itKeyChurchNameLocationAbove) {
				$massContent = 
					trim(str_replace ('$kosciol', $this->faraNazwaKosciola($intention->kosciolID), $churchStyle)).
					'<br/>'.'<a href='.$hyperlink.'>'.$config[itKeyFreeTimeText].'</a>';
			} else {
				$massContent = '<a href='.$hyperlink.'>'.$config[itKeyFreeTimeText].'</a><br/>'.
					trim(str_replace ('$kosciol', $this->faraNazwaKosciola($intention->kosciolID), $churchStyle));
			}	
			if ($bookmarkOnFree) $massContent = '<a name="w'.($freeOrderNo++).'"></a>'.$massContent;		
			$content .= '<td '.$config[itKeyFreeTimeCellStyle].'>'.$massContent.'</a></td>';	
			
		} else {
			if ($churchNameLocation==itKeyChurchNameLocationNone) {
				$massContent = $config[itKeyFreeTimeText];
			} else if ($churchNameLocation==itKeyChurchNameLocationAbove) {
				$massContent = 
					trim(str_replace ('$kosciol', $this->faraNazwaKosciola($intention->kosciolID), $churchStyle)).
					'<br/>'.$config[itKeyFreeTimeText];
			} else {
				$massContent = $config[itKeyFreeTimeText].'<br/>'.
					trim(str_replace ('$kosciol', $this->faraNazwaKosciola($intention->kosciolID), $churchStyle));
			}
			if ($bookmarkOnFree) $massContent = '<a name="w'.($freeOrderNo++).'"></a>'.$massContent;
			$content .= '<td '.$config[itKeyFreeTimeCellStyle].'>'.$massContent.'</td>';		
		}
	} else {
		if ($churchNameLocation==itKeyChurchNameLocationNone) {
			$massContent = trim ($intention->tresc);
		} else if ($churchNameLocation==itKeyChurchNameLocationAbove) {
			$massContent = 
				trim(str_replace ('$kosciol', $this->faraNazwaKosciola($intention->kosciolID), $churchStyle)).
				'<br/>'.trim ($intention->tresc);
		} else {
			$massContent = trim ($intention->tresc).'<br/>'.
				trim(str_replace ('$kosciol', $this->faraNazwaKosciola($intention->kosciolID), $churchStyle));
		}
		$content .= '<td '.$config[itKeyContentCellStyle].'>'.$massContent.'</td>';
	}
	$content .= '</tr>';
}
$content .= '</table>';
$content = $this->correctToUTF8($content);
return $content;
}

// Rekonfiguracja tabeli $intentions ze względu na łączenie treści o tym samym czasie
function rebuildIntentionsOnTheSameTime ($source, $config) {
if ($config[itKeyLinkContentsOnTheSameTime]!=itLinkContentYes) return $source;
$linkedType = 0;
if (strlen ($config [itKeyTypeOfLinkedContnetsOnTheSameTime]) > 0) {
	$query = 'SELECT `faraID` FROM `'.FARA_INTENTIONS_TYPES_TABLE.'` WHERE `nazwa`="'.$config[itKeyTypeOfLinkedContnetsOnTheSameTime].'"';
	$handle = mysqli_query ($this->con, $query);
	if (!$handle) $this->sendErrorMessage ('Zerwane połączenie z bazą danych w trakcie wykonywania funkcji "faraIntencje"'); 
	else if (mysqli_num_rows ($handle)>0) {
		$rec = mysqli_fetch_array ($handle);
		$linkedType = $rec[0];
	}
}
$index		= -1;
$lastDate	=  0;
$lastTime	= -1;
for ($row=0; $row<count($source); $row++) {
	$intention = $source[$row];
	// inny dzień
	if ($intention->data != $lastDate) {
		$lastDate = $intention->data;
		$buffer [++$index] = $intention;
		continue;
	}
	// ten sam dzień, inna godzina
	if ($intention->godzina != $lastTime) {
		$lastTime = $intention->godzina;
		$buffer [++$index] = $intention;
		continue;
	}
	// ten sam czas, ale termin wolny
	if ($intention->wolny == FARA_TERMIN_WOLNY) {
		$buffer [++$index] = $intention;
		continue;
	}
	// ten sam czas i łączenie bezwarunkowe
	if ($linkedType==0) {
		$buffer[$index]->tresc .= $config[itKeySeparatorContentsOnTheSameTime].$intention->tresc;
		continue ;
	}
	// ten sam czas - łączenie warunkowe - inny typ
	if ($intention->typID != $linkedType) {
		$buffer [++$index] = $intention;
		continue;
	}
	// ten sam czas - łączenie warunkowe - zgodny typ
	$buffer[$index]->tresc .= $config[itKeySeparatorContentsOnTheSameTime].$intention->tresc;	
}
return $buffer;
}

function faraPatroniDnia ($date) {
$month	= $this->getMonth ($date);
$day	= $this->getDayOfMonth ($date);
$query	= 'SELECT `nazwa`,`typ` FROM `'.FARA_SAINTS_TABLE.'` WHERE dzien='.$day.' and miesiac='.$month.' ORDER BY `typ` DESC, `nazwa`';
$handle = mysqli_query ($this->con, $query);
if (!$handle) {
	$this->sendErrorMessage ('Zerwane połączenie z bazą danych w trakcie wykonywania funkcji "faraPatroniDnia"'); 
	return '';
}
$rowsInResult = mysqli_num_rows ($handle);
if ($rowsInResult == 0) return '';
$result = '';
for ($row=0; $row<$rowsInResult; $row++) {
	$record = mysqli_fetch_object ($handle);	
	if ($result) $result .= ', ';
	if ($record->typ) $result .= $record->typ.' ';
	$result .= $record->nazwa;
}
$query	= 'SELECT `nazwa` FROM `'.FARA_USER_SAINTS_TABLE.'` WHERE dzien='.$day.' and miesiac='.$month.' ORDER BY `nazwa`';
$handle = mysqli_query ($this->con, $query);
if (!$handle) {
	$this->sendErrorMessage ('Zerwane połączenie z bazą danych w trakcie wykonywania funkcji "faraPatroniDnia"'); 
	return $result;
}
$rowsInResult = mysqli_num_rows ($handle);
if ($rowsInResult == 0) return $result;
for ($row=0; $row<$rowsInResult; $row++) {
	$record = mysqli_fetch_object ($handle);	
	if ($result) $result .= ', ';
	if ($record->typ) $result .= $record->typ.' ';
	$result .= $record->nazwa;
}
$result = $this->correctToUTF8($result);
return $result;
}

function faraSwietoStale ($date) {
$month	= $this->getMonth ($date);
$day	= $this->getDayOfMonth ($date);
$query	= 'SELECT `nazwa` FROM `'.FARA_CCELEBRATIONS_TABLE.'` WHERE dzien='.$day.' and miesiac='.$month.' ORDER BY `nazwa`';
$handle = mysqli_query ($this->con, $query);
if (!$handle) {
	$this->sendErrorMessage ('Zerwane połączenie z bazą danych w trakcie wykonywania funkcji "faraSwietoStale"'); 
	return '';
}
$rowsInResult = mysqli_num_rows ($handle);
if ($rowsInResult == 0) return '';
$result = '';
for ($row=0; $row<$rowsInResult; $row++) {
	$record = mysqli_fetch_object ($handle);	
	if ($result) $result .= ', ';
	$result .= $record->nazwa;
}
$result = $this->correctToUTF8($result);
return $result;
}

function faraSwietoRuchome ($date) {
$query	= 'SELECT `nazwa`,`typ` FROM `'.FARA_MCELEBRATIONS_TABLE.'` WHERE `data`='.$date;
$handle = mysqli_query ($this->con, $query);
if (!$handle) {
	$this->sendErrorMessage ('Zerwane połączenie z bazą danych w trakcie wykonywania funkcji "faraPatroniDnia"'); 
	return '';
}
$rowsInResult = mysqli_num_rows ($handle);
if ($rowsInResult == 0) return '';
$result = '';
for ($row=0; $row<$rowsInResult; $row++) {
	$record = mysqli_fetch_object ($handle);	
	if ($result) $result .= ', ';
	if ($record->typ) $result .= $record->typ.' ';
	$result .= $record->nazwa;
}
$result = $this->correctToUTF8($result);
return $result;
}

function faraTypIntencji ($typ) {
$query = 'SELECT * FROM `'.FARA_INTENTIONS_TYPES_TABLE.'` WHERE '.
(($this->isNumber ($typ)) ? '`faraID`='.$typ : '`nazwa`="'.$typ.'"');
$handle = mysqli_query ($this->con, $query);
if (!$handle) {
	$this->sendErrorMessage ('Zerwane połączenie z bazą danych w trakcie wykonywania funkcji "faraTypIntencji": '.$query); 
	return ($this->isNumber ($typ)) ? '':0;
}
$record = mysqli_fetch_object ($handle);
return ($this->isNumber ($typ)) ? $this->correctToUTF8($record->nazwa): $record->faraID;	
}

function faraNazwaKosciola ($id) {
$query = 'SELECT nazwa FROM `'.FARA_CHURCHES_TABLE.'` WHERE faraID='.$id;
$handle = mysqli_query ($this->con, $query);
if (!$handle) {
	$this->sendErrorMessage ('Zerwane połączenie z bazą danych w trakcie wykonywania funkcji "faraNazwaKosciola": '.$query); 
	return '';
}
$record = mysqli_fetch_object ($handle);
return $this->correctToUTF8($record->nazwa);
}

// FUNKCJE POMOCNICZE
function scriptDateFromString ($stringDate) {
$length = strlen ($stringDate);
if ($length == 8) return $stringDate;
if ($length != 10) return '';
if (!in_array (substr ($stringDate, 2, 1),  array ('0','1', '2', '3', '4', '5', '6', '7', '8', '9'))) 
	return substr ($stringDate, 6, 4).substr ($stringDate, 3, 2).substr ($stringDate, 0, 2);
if (!in_array (substr ($stringDate, 4, 1),  array ('0','1', '2', '3', '4', '5', '6', '7', '8', '9'))) 
	return substr ($stringDate, 0, 4).substr ($stringDate, 5, 2).substr ($stringDate, 8, 2);
return '';
}
function stringFromScriptDate() {
    $scriptDate = func_get_arg (0);
    $format		= (func_num_args () > 1) ? func_get_arg (1) : FARA_FORMAT_DATY_DOMYSLNY;

    $year 	= intval ($scriptDate/10000);
    $month	= intval (($scriptDate%10000)/100);
    $day	= $scriptDate%100;
    
    $date = new DateTime();
    $date->setDate($year, $month, $day);

    $formatter = new IntlDateFormatter('pl_PL', IntlDateFormatter::FULL, IntlDateFormatter::NONE);

    $format = str_replace ("%m", "MM", $format);
    $format = str_replace ("%Y", "Y", $format);
    $format = str_replace ("%d", "dd", $format);
    $format = str_replace ("%A", "EEEE", $format);
    $format = str_replace ("%B", "MMMM", $format);

    $formatter->setPattern($format);
    $result = $formatter->format($date);

    return $result;
}
function wycofane_stringFromScriptDate () {
$scriptDate = func_get_arg (0);
$format		= (func_num_args () > 1) ? func_get_arg (1) : FARA_FORMAT_DATY_DOMYSLNY;
$useStrf	= (func_num_args () > 2) ? func_get_arg (2) : FALSE;
if (strlen ($scriptDate)==0) return '';
$year 	= intval ($scriptDate/10000);
$month	= intval (($scriptDate%10000)/100);
$day	= $scriptDate%100;
$time	= mktime (0, 0, 0, $month, $day, $year);
//$result	= strftime($format,$time); => strftime wycofane w PHP 8.x i 9

if (is_int (strpos ($format,'%A'))) {
	$result = str_replace ('Monday', 'Poniedziałek', $result);
	$result = str_replace ('Tuesday', 'Wtorek', $result);
	$result = str_replace ('Wednesday', 'Środa', $result);
	$result = str_replace ('Thursday', 'Czwartek', $result);
	$result = str_replace ('Friday', 'Piątek', $result);
	$result = str_replace ('Saturday', 'Sobota', $result);
	$result = str_replace ('Sunday', 'Niedziela', $result);
}
if (is_int (strpos ($format,'%B'))) {
	$result = str_replace ('January', 'stycznia', $result);
	$result = str_replace ('February', 'lutego', $result);
	$result = str_replace ('March', 'marca', $result);
	$result = str_replace ('April', 'kwietnia', $result);
	$result = str_replace ('May', 'maja', $result);
	$result = str_replace ('June', 'czerwca', $result);
	$result = str_replace ('July', 'lipca', $result);
	$result = str_replace ('August', 'sierpnia', $result);
	$result = str_replace ('September', 'września', $result);
	$result = str_replace ('October', 'października', $result);
	$result = str_replace ('November', 'listopada', $result);
	$result = str_replace ('December', 'grudnia', $result);
	
	$result = str_replace ('Styczeń', 'stycznia', $result);
	$result = str_replace ('Luty', 'lutego', $result);
	$result = str_replace ('Marzec', 'marca', $result);
	$result = str_replace ('Kwiecień', 'kwietnia', $result);
	$result = str_replace ('Maj', 'maja', $result);
	$result = str_replace ('Czerwiec', 'czerwca', $result);
	$result = str_replace ('Lipiec', 'lipca', $result);
	$result = str_replace ('Sierpień', 'sierpnia', $result);
	$result = str_replace ('Wrzesień', 'września', $result);
	$result = str_replace ('Październik', 'października', $result);
	$result = str_replace ('Listopad', 'listopada', $result);
	$result = str_replace ('Grudzień', 'grudnia', $result);
}
return $result;
}

function incScriptDate () {
$scriptDate	= func_get_arg (0);
$count		= (func_num_args () > 1) ? func_get_arg (1) : 1;
if ($count==0) return $scriptDate;
$year 		= intval ($scriptDate/10000);
$month		= intval (($scriptDate%10000)/100);
$day		= $scriptDate%100;
$lastDate	= $scriptDate;
$duration	= abs ($count);
for ($counter=1; $counter<=$duration; $counter++) {
	$time	 = mktime (0, 0, 0, $month, $day, $year)+(($count>=0) ? 1: -1)*24*60*60;
	$newDate = date('Ymd', $time);
	// korekta na zmianę czasu
	while ($newDate == $lastDate) {$time=$time+(($count>=0) ? 1: -1)*24*60*60; $newDate = date('Ymd', $time);}
	$lastDate = $newDate;
	$year 		= intval ($newDate/10000);
	$month		= intval (($newDate%10000)/100);
	$day		= $newDate%100;	
}
return intval($newDate);
}

function isNumber ($value) {
if (gettype ($value)=="integer") return 1;
if (strval(intval($value))==$value) return 1;
return 0;
}

function today () {
return intval (date ('Ymd'));
}

function unixTime ($date) {
$year 	= intval ($date/10000);
$month	= intval (($date%10000)/100);
$day	= $date%100;
$time	= mktime (0, 0, 0, $month, $day, $year);
return $time;
}

function dayOfWeek ($date) {
$time = $this->unixTime ($date);
$dow  = date ('w', $time) + 1;
if ($dow==8) $dow = 1;
return $dow;
}

function nextWeekDate () {
$date 	= (func_num_args () > 1) ? func_get_arg (0) : $this->today();
$dow	= $this->dayOfWeek ($date);
while ($this->dayOfWeek ($date)!=1) $date = $this->incScriptDate($date);
return $date;
}

function thisWeekDate () {
$date 	= (func_num_args () > 1) ? func_get_arg (0) : $this->today();
$dow	= $this->dayOfWeek ($date);
while ($this->dayOfWeek ($date)!=1) $date = $this->incScriptDate($date, -1); 
return $date;
}

function getMonth ($date) {
$time = $this->unixTime ($date);
$month = date ('m', $time);
return $month;
}

function getDayOfMonth ($date) {
$time = $this->unixTime ($date);
$day = date ('d', $time);
return $day;
}

function getYear ($date) {
return gmdate('Y',$this->unixTime($date));
}

function nextMonthDate () {
$date 	= (func_num_args () > 1) ? func_get_arg (0) : $this->today();
$month	= $this->getMonth($date);
$year	= $this->getYear ($date);
if ($month==12) {$month = 1; $year++;} else {$month++;}	
return date ('Ymd', mktime (0, 0, 0, $month, 1, $year));
}

function addMonthsDate () {
$monthsCount = func_get_arg (0);
$date 	= (func_num_args () > 2) ? func_get_arg (1) : $this->today();
$month	= $this->getMonth($date);
$year	= $this->getYear ($date);
for ($monthIndex=1; $monthIndex<$monthsCount; $monthIndex++) {
	if ($month==12) {$month = 1; $year++;} else {$month++;}	
}
$newDate = new DateTime(date ('Ymd', mktime (0, 0, 0, $month, 1, $year)));
$newDate->modify('last day of this month');
return $newDate->format('Ymd');
}

function thisMonthDate () {
$date 	= (func_num_args () > 1) ? func_get_arg (0) : $this->today();
$month	= $this->getMonth($date);
$year	= $this->getYear ($date);
return date ('Ymd', mktime (0, 0, 0, $month, 1, $year));
}

function nextYearDate () {
$date 	= (func_num_args () > 0) ? func_get_arg (0) : $this->today();
$year	= $this->getYear ($date);
return date ('Ymd', mktime (0, 0, 0, 1, 1, $year+1));
}

function thisYearDate () {
$date 	= (func_num_args () > 0) ? func_get_arg (0) : $this->today();
$year	= $this->getYear ($date);
return date ('Ymd', mktime (0, 0, 0, 1, 1, $year));
}

function getStartDate ($startDate) {
// Funkcja zwraca $startDate jeśli jest ona nie starsza niż dzisiaj, dzisiaj w przeciwnym przypadku
$date1 = $this->scriptDateFromString ($startDate);
return ($date1 >= $this->today()) ? $date1 : $this->today();
}

function getFirstDate () {
// Funkcja zwraca początkową datę z bazy danych
if ($this->history==FARA_INTENCJE_WSZYSTKO) {
	return 0;	// No chyba raczej tak !!!
	$query 	= 'SELECT min(`data`) as minDate FROM `'.FARA_INTENTIONS_TABLE.'`';
	$handle = mysqli_query ($this->con, $query);
	if (mysqli_num_rows ($handle)==0) return 0;
	$record	= mysqli_fetch_array ($handle);
	return $record[0];
}
if ($this->history==FARA_INTENCJE_OD_DZISIAJ) return $this->today();
if ($this->history==FARA_INTENCJE_OD_BIEZACEGO_TYGODNIA) return $this->thisWeekDate();
if ($this->history==FARA_INTENCJE_OD_BIEZACEGO_MIESIACA) return $this->thisMonthDate();
if ($this->history==FARA_INTENCJE_OD_POCZATKU_ROKU) return $this->thisYearDate();
return $this->today();
}

function transform ($what, $with, $where) {
$buffer = str_replace (strtoupper ($what), $with, $where);
$buffer = str_replace (strtolower ($what), $with, $buffer);
return $buffer;
}

function removeEmptyRowsFrom2DimensionsCalendar ($calendar) {
// Usunięcie z tablicy wynikowej wierszy pustych, tj. zawierajacych samą datę - bez godzin
$day = -1;
foreach ($calendar as $tableRow) {
	$numberOfColumns = count ($tableRow);
	//echo 'Data: '.$tableRow[0].'  $numberOfColumns: '.$numberOfColumns.'<br/>';
	if ($numberOfColumns>1) {
		$day++;
		for ($column=0; $column<$numberOfColumns; $column++)  {
			//echo '&nbsp;&nbsp;&nbsp;$column: '.$column.'   $tableRow[$column]: '.$tableRow[$column].'<br.>';
			$newCalendar [$day][$column] = $tableRow[$column];
		}
	}
}
return (count ($newCalendar)==0) ? FALSE: $newCalendar;
}

function addEmptyRowsTo2DimensionsCalendar ($calendar, $startDate, $endDate) {
$row	= -1;
$date	= $startDate;
while ($date <= $endDate) {
	$row++;
	$rowInCalendar = $this->rowNumberInCalendar ($calendar, $date);		
	if ($rowInCalendar>=0) {		
		for ($column=0; $column<count($calendar[$rowInCalendar]); $column++) {
			$newCalendar [$row][$column] = $calendar [$rowInCalendar][$column];
		}		
	} else {
		$newCalendar [$row][0] = $date;
	}
	$date = $this->incScriptDate ($date);
}
return $newCalendar;
}

function rowNumberInCalendar ($calendar, $date) {
for ($row=0; $row < count ($calendar); $row++)
	if ($calendar [$row][0] == $date) 
		return $row;
return -1;
}

function fileNameExtension ($fileName) {
$elements = explode ('.', $fileName);
if (!$elements or count ($elements)==1) return '';
return strtolower ($elements[count($elements)-1]);
}

function getConfigFileName () {
$fileName = (func_num_args () > 0) ? func_get_arg (0) : '';
if (strlen ($fileName)==0) 		return FARA_DEFAULT_INI_STYLES_FILE;
if (!file_exists ($fileName)) 	return FARA_DEFAULT_INI_STYLES_FILE;
return $fileName;
}

function iniGetSection ($section, $configFile) {	
$content = parse_ini_file ($configFile, TRUE, INI_SCANNER_TYPED);
return $content[$section];
}



function zapiszZgloszenie () {
$data 		= (func_num_args () > 0) ? func_get_arg (0) : '';
$godzina 	= (func_num_args () > 1) ? func_get_arg (1) : '';
$tresc		= (func_num_args () > 2) ? func_get_arg (2) : '';
$zamawia	= (func_num_args () > 3) ? func_get_arg (3) : '';
$uwagi		= (func_num_args () > 4) ? func_get_arg (4) : '';
$typ		= (func_num_args () > 5) ? func_get_arg (5) : 0;
$kosciol	= (func_num_args () > 6) ? func_get_arg (6) : 0;
$telefon	= (func_num_args () > 7) ? func_get_arg (7) : '';
$email		= (func_num_args () > 8) ? func_get_arg (8) : '';

$ip			 = getenv ("REMOTE_ADDR");
$host		 = gethostbyaddr ($ip);
$currentTime = date ('d/m/Y H:i');
$content 	 = "<?xml version=\"1.0\" encoding=\"utf-8\"?>
<zgloszenie>
  <record>
   <ip>$ip</ip>
   <host>$host</host>
   <time>$currentTime</time>
   <data>$data</data>
   <godzina>$godzina</godzina>
   <tresc>$tresc</tresc>
   <zamawia>$zamawia</zamawia>
   <uwagi>$uwagi</uwagi>
   <typ>$typNazwa</typ>
   <kosciol>$kosciol</kosciol>
   <telefon>$telefon</telefon>
   <email>$email</email>
  </record>
</zgloszenie>";
$this->saveContentToUniqueFile ($content, 'xml');
}

function wyslijZgloszenie () {
$data 		= (func_num_args () > 0) ? func_get_arg (0) : '';
$godzina 	= (func_num_args () > 1) ? func_get_arg (1) : '';
$tresc		= (func_num_args () > 2) ? func_get_arg (2) : '';
$zamawia	= (func_num_args () > 3) ? func_get_arg (3) : '';
$uwagi		= (func_num_args () > 4) ? func_get_arg (4) : '';
$typ		= (func_num_args () > 5) ? func_get_arg (5) : 0;
$kosciol	= (func_num_args () > 6) ? func_get_arg (6) : 0;
$telefon	= (func_num_args () > 7) ? func_get_arg (7) : '';
$email		= (func_num_args () > 8) ? func_get_arg (8) : '';

if ($this->isNumber ($typ)) {
	$typNazwa = $this->faraTypIntencji ($typ);
} else {
	$typNazwa = $typ;
	$typ = $this->faraTypIntencji ($typ);
}
$config 	= $this->iniGetSection ('zgloszenia', $this->getConfigFileName());
$walidacja	= $config[zgWalidacja];
if ($walidacja) {
	if ($typ>0) {
		$bezWalidacji = $config[zgTypNieWalidowany];
		if (!$this->isNumber($bezWalidacji)) $bezWalidacji = $this->faraTypIntencji($bezWalidacji);
		$walidacja = ($typ != $bezWalidacji);
	}
}

// Próba pobrania źródłowego (z programu FARA) identyfikatora intencji 
$query = 'SELECT `faraID` FROM `'.FARA_INTENTIONS_TABLE.'` WHERE `data`='.$this->scriptDateFromString($data).
		' and `godzina`='.str_replace (':', '', $godzina);
if ($walidacja) $query .= ' and `wolny`='.FARA_TERMIN_WOLNY;		
if ($kosciol>0) $query .= ' and `kosciolID`='.$kosciol;
if ($typ>0) $query .= ' and `typID`='.$typ;

$handle = mysqli_query ($this->con, $query);
if (mysqli_num_rows ($handle)==0) {
	// Nie znaleziono takiego terminu
	if ($walidacja) return FARA_ZGLOSZENIE_TERMIN_ZAJETY;
	$faraID = 0;
} else {
	$record	= mysqli_fetch_object ($handle);
	$faraID = $record->faraID;
}
if ($faraID>0) {
	// Rezerwacja znalezionego terminu
	$sql = 'UPDATE `'.FARA_INTENTIONS_TABLE.'` SET `wolny`='.FARA_TERMIN_ZAJETY.' WHERE `faraID`='.$faraID;		
	if (!mysqli_query ($this->con, $sql)) {
		$this->sendErrorMessage ('Nie można zarezerwować zgłoszenia: '.$query);	 
		return FARA_ZGLOSZENIE_BLAD_WYSYLANIA;
	}
	$sql = 'UPDATE `'.FARA_INTENTIONS_TABLE.'` SET `tresc`="'.$config[zgRezerwowanie].'" WHERE `faraID`='.$faraID.' and length(`tresc`)=0';
	if (!mysqli_query ($this->con, $sql)) {
		$this->sendErrorMessage ('Nie można zarezerwować zgłoszenia: '.$query);	 
		return FARA_ZGLOSZENIE_BLAD_WYSYLANIA;
	}
}	
  
$ip			 = getenv ("REMOTE_ADDR");
$host		 = gethostbyaddr ($ip);
$currentTime = date ('d/m/Y H:i');
$content 	 = "<?xml version=\"1.0\" encoding=\"utf-8\"?>
<zgloszenie>
  <record>
   <ip>$ip</ip>
   <host>$host</host>
   <time>$currentTime</time>
   <data>$data</data>
   <godzina>$godzina</godzina>
   <tresc>$tresc</tresc>
   <zamawia>$zamawia</zamawia>
   <uwagi>$uwagi</uwagi>
   <faraid>$faraID</faraid>
   <typ>$typNazwa</typ>
   <kosciol>$kosciol</kosciol>
   <telefon>$telefon</telefon>
   <email>$email</email>
  </record>
</zgloszenie>";
$this->saveContentToUniqueFile ($content, 'xml');

// Wysłanie zgłoszenia emailem
if ($this->emailWithRequest) {
	$body = "Zamówienie intencji";
	if ($kosciol) $body .= " w kościele ".$this->faraNazwaKosciola($kosciol);
	$body .= "
na dzień $data, godzinę $godzina o treści

$tresc

Zamawiający:
$zamawia
telefon: ".(($telefon) ? $telefon : " - nie podano -")."
email: ".(($email) ? $email : " - nie podano -")."
";
	if ($typNazwa) $body .= "Typ: ".$typNazwa;
	if ($uwagi) $body .= "
Uwagi dodatkowe:
$uwagi
";
	$body .= "
Wysłano $currentTime z adresu IP $ip ($host)
przez moduł FARA-INTENCJE ONLINE";
	$subject_text = "FARA: Zamówienie intencji na ".$data." ".$godzina;
	$subject = '=?UTF-8?B?' . base64_encode($subject_text) . '?=';	
	$body = base64_encode($body);	
	$headers = 'Content-Type: text/plain; charset=utf-8' . "\r\n";
	$headers .= 'Content-Transfer-Encoding: base64' . "\r\n";
	$headers .= 'From: ' . $this->emailSender;	
	mail ($this->emailWithRequest, $subject, $body, $headers);
}
return FARA_ZGLOSZENIE_TERMIN_PRZYJETY;
}


function saveContentToUniqueFile ($content, $extension) {
$fname = time().str_replace ('.', '', getenv ("REMOTE_ADDR"));
$fileName = $fname;
$i=0;
while (file_exists ($this->dbSourceFolder.'/'.FARA_ZGLOSZENIA_FOLDER.'/'.$fileName.'.'.$extension)) {
	$fileName = $fname.$i++;
}	
file_put_contents ($this->dbSourceFolder.'/'.FARA_ZGLOSZENIA_FOLDER.'/'.$fileName.'.'.$extension, $content);
}

function correctToUTF8 ($text) {
if ($this->UTF8correction==0) return $text;
$content = str_replace("Ä„","Ą",$text);
$content = str_replace("Ä…","ą",$content);
$content = str_replace("Ä†","Ć",$content);
$content = str_replace("Ä‡","ć",$content);
$content = str_replace("Ä","Ę",$content);
$content = str_replace("Ä™","ę",$content);
$content = str_replace("Å","Ł",$content);
$content = str_replace("Å‚","ł",$content);
$content = str_replace("Å","Ń",$content);
$content = str_replace("Å„","ń",$content);
$content = str_replace("Ă“","Ó",$content);
$content = str_replace("Ã³","ó",$content);
$content = str_replace("Åš","Ś",$content);
$content = str_replace("Å›","ś",$content);
$content = str_replace("Å»","Ż",$content);
$content = str_replace("Å¼","ż",$content);
$content = str_replace("Ĺą","Ź",$content);
$content = str_replace("Ĺş","ź",$content);
return $content;
}

} // END OF CLASS DEFINITION

class FaraIntentionTime {
	var $data;
	var $godzina;
	var $stan;
	var $kosciol;

function __construct ($date, $time, $state, $church) {
	$this->data		= $date;
	$this->godzina 	= number_format ($time/100, 2, ':', '');
	$this->stan 	= $state;
	$this->kosciol	= $church;
}
	
} // END OF CLASS DEFINITION


?>